# WARNING: Please don't edit this file. It was generated by Python/WinRT v2.2.0

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections
import winrt.windows.storage as windows_storage
import winrt.windows.system as windows_system

from winrt.windows.storage.accesscache import AccessCacheOptions, RecentStorageItemVisibility

Self = typing.TypeVar('Self')

@typing.final
class AccessListEntry:
    token: str
    metadata: str
    def __init__(self, token: str, metadata: str) -> None: ...

@typing.final
class AccessListEntryView(winrt.system.Object, winrt._winrt.Sequence[AccessListEntry]):
    def __len__(self) -> int: ...
    def __iter__(self) -> windows_foundation_collections.IIterator[AccessListEntry]: ...
    @typing.overload
    def __getitem__(self, index: typing.SupportsIndex) -> AccessListEntry: ...
    @typing.overload
    def __getitem__(self, index: slice) -> winrt.system.Array[AccessListEntry]: ...
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> AccessListEntryView: ...
    def first(self) -> typing.Optional[windows_foundation_collections.IIterator[AccessListEntry]]: ...
    def get_at(self, index: winrt.system.UInt32, /) -> AccessListEntry: ...
    def get_many(self, start_index: winrt.system.UInt32, items: winrt.system.Array[AccessListEntry], /) -> winrt.system.UInt32: ...
    def index_of(self, value: AccessListEntry, /) -> typing.Tuple[bool, winrt.system.UInt32]: ...
    @_property
    def size(self) -> winrt.system.UInt32: ...

@typing.final
class ItemRemovedEventArgs(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> ItemRemovedEventArgs: ...
    @_property
    def removed_entry(self) -> AccessListEntry: ...

@typing.final
class StorageApplicationPermissions_Static(type):
    def get_future_access_list_for_user(cls, user: typing.Optional[windows_system.User], /) -> typing.Optional[StorageItemAccessList]: ...
    def get_most_recently_used_list_for_user(cls, user: typing.Optional[windows_system.User], /) -> typing.Optional[StorageItemMostRecentlyUsedList]: ...
    @_property
    def future_access_list(cls) -> typing.Optional[StorageItemAccessList]: ...
    @_property
    def most_recently_used_list(cls) -> typing.Optional[StorageItemMostRecentlyUsedList]: ...

@typing.final
class StorageApplicationPermissions(winrt.system.Object, metaclass=StorageApplicationPermissions_Static):
    pass

@typing.final
class StorageItemAccessList(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> StorageItemAccessList: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], /) -> str: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], metadata: str, /) -> str: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], /) -> None: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], metadata: str, /) -> None: ...
    def check_access(self, file: typing.Optional[windows_storage.IStorageItem], /) -> bool: ...
    def clear(self) -> None: ...
    def contains_item(self, token: str, /) -> bool: ...
    @typing.overload
    def get_file_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFile]: ...
    @typing.overload
    def get_file_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFile]: ...
    @typing.overload
    def get_folder_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFolder]: ...
    @typing.overload
    def get_folder_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFolder]: ...
    @typing.overload
    def get_item_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.IStorageItem]: ...
    @typing.overload
    def get_item_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.IStorageItem]: ...
    def remove(self, token: str, /) -> None: ...
    @_property
    def entries(self) -> typing.Optional[AccessListEntryView]: ...
    @_property
    def maximum_items_allowed(self) -> winrt.system.UInt32: ...

@typing.final
class StorageItemMostRecentlyUsedList(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> StorageItemMostRecentlyUsedList: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], /) -> str: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], metadata: str, /) -> str: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], metadata: str, visibility: RecentStorageItemVisibility, /) -> str: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], /) -> None: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], metadata: str, /) -> None: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], metadata: str, visibility: RecentStorageItemVisibility, /) -> None: ...
    def check_access(self, file: typing.Optional[windows_storage.IStorageItem], /) -> bool: ...
    def clear(self) -> None: ...
    def contains_item(self, token: str, /) -> bool: ...
    @typing.overload
    def get_file_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFile]: ...
    @typing.overload
    def get_file_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFile]: ...
    @typing.overload
    def get_folder_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFolder]: ...
    @typing.overload
    def get_folder_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFolder]: ...
    @typing.overload
    def get_item_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.IStorageItem]: ...
    @typing.overload
    def get_item_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.IStorageItem]: ...
    def remove(self, token: str, /) -> None: ...
    def add_item_removed(self, handler: windows_foundation.TypedEventHandler[StorageItemMostRecentlyUsedList, ItemRemovedEventArgs], /) -> windows_foundation.EventRegistrationToken: ...
    def remove_item_removed(self, event_cookie: windows_foundation.EventRegistrationToken, /) -> None: ...
    @_property
    def entries(self) -> typing.Optional[AccessListEntryView]: ...
    @_property
    def maximum_items_allowed(self) -> winrt.system.UInt32: ...

@typing.final
class IStorageItemAccessList(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> IStorageItemAccessList: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], /) -> str: ...
    @typing.overload
    def add(self, file: typing.Optional[windows_storage.IStorageItem], metadata: str, /) -> str: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], /) -> None: ...
    @typing.overload
    def add_or_replace(self, token: str, file: typing.Optional[windows_storage.IStorageItem], metadata: str, /) -> None: ...
    def check_access(self, file: typing.Optional[windows_storage.IStorageItem], /) -> bool: ...
    def clear(self) -> None: ...
    def contains_item(self, token: str, /) -> bool: ...
    @typing.overload
    def get_file_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFile]: ...
    @typing.overload
    def get_file_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFile]: ...
    @typing.overload
    def get_folder_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFolder]: ...
    @typing.overload
    def get_folder_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.StorageFolder]: ...
    @typing.overload
    def get_item_async(self, token: str, /) -> windows_foundation.IAsyncOperation[windows_storage.IStorageItem]: ...
    @typing.overload
    def get_item_async(self, token: str, options: AccessCacheOptions, /) -> windows_foundation.IAsyncOperation[windows_storage.IStorageItem]: ...
    def remove(self, token: str, /) -> None: ...
    @_property
    def entries(self) -> typing.Optional[AccessListEntryView]: ...
    @_property
    def maximum_items_allowed(self) -> winrt.system.UInt32: ...

